Unit ftreat74e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, DE70EC_p;

function ftreat74e(S :Integer; XI :Extended; XE :Extended; Y :Extended;
                var AY :Array of Extended; var ADY :Array of Extended;
                var M :Integer; var KP1 :Integer;
                KP2 :Integer): String;

implementation

function ftreat74e(S :Integer; XI :Extended; XE :Extended; Y :Extended;
                var AY :Array of Extended; var ADY :Array of Extended;
                var M :Integer; var KP1 :Integer;
                KP2 :Integer): String;
var
L,J :Integer;
YT,MIDPNT,ALPN,SOL,SOLT,Q :Extended;
BK :Array [0..1] of Extended;
label
_20;
begin
Result := '';  {   }
{  }
Result := Result + Format(''+#$0D#$0A+' COEFFICIENTS AY AND ADY ON %3d   SEGMENT:  '+#$0D#$0A+' XI=%30.18e      XE=%30.18e ',
 [S,XI,XE]) + #$0D#$0A;
Q := 4.e0;
YT := Exp(Q*(XE+1.e0));
Result := Result + Format(' Solution Y and YT at the end  of the segment [XI,XE],i.e. Y(XE), YT(XE):'+#$0D#$0A+' Y =%30.18e  '+#$0D#$0A+'YT=%30.18e  '+#$0D#$0A+'(YT-Y)/Y=%30.18e '+#$0D#$0A+'',
 [Y,YT,(YT-Y)/Y]) + #$0D#$0A;
{  }
MIDPNT := 0.5e0*(XI+XE);
{  }
{    Transformation of point MIDPNT into a point ALPN of segment [-1, 1] }
{  }
ALPN := 2.e0*(MIDPNT-XI)/(XE-XI)-1.e0;
{  }
{    Calculation of partial sum SOL of KP1 order with Chebyshev coefficie }
{         at point ALPN  (BK - working array  of dimension M*2) }
{  }
DE70EC(M,KP1,ALPN,AY,SOL,BK);
SOLT := Exp(Q*(MIDPNT+1.e0));
Result := Result + Format(''+#$0D#$0A+' MIDPNT=%30.18e ',
 [MIDPNT]) + #$0D#$0A;
Result := Result + Format(''+#$0D#$0A+' Solution SOL and SOLT at the midpoint 0.5*(XI+XE)  of segment [XI, XE]:  '+#$0D#$0A+'  SOL=%30.18e  '+#$0D#$0A+'SOLT=%30.18e  '+#$0D#$0A+'(SOLT-SOL)/SOL=%30.18e '+#$0D#$0A+#$0D#$0A+'',
 [SOL,SOLT,(SOLT-SOL)/SOL]) + #$0D#$0A;
{  }
for L:=1 to M do
 begin
  Result := Result + Format(''+#$0D#$0A+'   Number of       Chebyshev coefficients for %1d ',
 [L]);
  Result := Result + Format('%s',
 [' component'+#$0D#$0A+'              ---------------------------------------------------'+#$0D#$0A+' coefficient           for Y                     for Y'''+#$0D#$0A+' ----------------------------------------------------------------']) + #$0D#$0A;
  for J:=1 to KP1 do
   begin
    Result := Result + Format('     %2d      %30.18e %30.18e ',
 [J-1,AY[(L-1)+(J-1)*M],ADY[(L-1)+(J-1)*M]]) + #$0D#$0A;
   end;
  Result := Result + Format('     %2d      %30.18e ',
 [KP1,AY[(L-1)+(KP2-1)*M]]) + #$0D#$0A;
_20:
 end;
Result := Result + Format('%s',
 [ #$0D#$0A' ****************************************************************' + #$0D#$0A]);
UtResAdd(ExtractFilePath(ParamStr(0))+'ftreat74e',Result);  {     ftreat74e.txt }
exit;
{  }
end;

end.
