Unit tde74e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, ftde74e_p, ftreat74e_p, DE74E_p;

function tde74e: String;

implementation

function tde74e: String;
var
M,K0,INIAPR,IMAX,IU,MEXACT,MESTER,K20,IMAX2,NATTEM,IERR :Integer;
XN,YN,XK,EPS,THRESH,H,HMIN,Y,YT :Extended;
RAB :Array [0..1696] of Extended;
const
K :Integer = 18;
K2 :Integer = 25;
begin
Result := '';  {   }
M := 1;
_BLOCK.elm2 := 4.0e0;
XN := 0.0;
YN := Exp(_BLOCK.elm2);
XK := 7.e0;
YT := Exp(_BLOCK.elm2*(XK+1.e0));
K0 := K;
INIAPR := 1;
IMAX := 28;
IU := 2;
EPS := 0.5e-13;
THRESH := 1.e0;
MEXACT := 1;
MESTER := 1;
H := 1.e0;
HMIN := 1.e-3;
K20 := K2;
IMAX2 := 3;
NATTEM := 3;
_BLOCK.elm1 := 0;
DE74E(ftde74e,ftreat74e,M,XN,YN,XK,K0,INIAPR,IMAX,IU,EPS,THRESH,
     MEXACT,M,MESTER,H,HMIN,K20,IMAX2,NATTEM,Y,RAB,IERR);
Result := Result + Format(' IERR=%2d ',[IERR]) + #$0D#$0A;
Result := Result + Format(' N=%12d ',[_BLOCK.elm1]) + #$0D#$0A;
Result := Result + Format(' NACCEP=%4d      NREJEC=%4d ',
 [_STAT76.elm1,_STAT76.elm2]) + #$0D#$0A;
Result := Result + Format(' Y =%30.18e  '+#$0D#$0A+'YT=%30.18e  '+#$0D#$0A+'(YT-Y)/Y=%30.18e '+#$0D#$0A+'',
 [Y,YT,(YT-Y)/Y]) + #$0D#$0A;
UtRes('tde74e',Result);  {     tde74e.txt }
exit;
end;

end.
